## org.apache.tools.ant.taskdefs
Class DefBase

    java.lang.Object
      |
      +--org.apache.tools.ant.ProjectComponent
            |
            +--org.apache.tools.ant.Task
                  |
                  +--org.apache.tools.ant.taskdefs.AntlibDefinition
                        |
                        +--org.apache.tools.ant.taskdefs.DefBase

Direct Known Subclasses:
  Definer, ScriptDef

public abstract class DefBase
extends AntlibDefinition

Base class for Definitions handling uri and class loading. (This was part of Definer)

Since:
  Ant 1.6

Field Summary

Fields inherited from class org.apache.tools.ant.Task
`description, location, target, taskName, taskType, wrapper`

Fields inherited from class org.apache.tools.ant.ProjectComponent
`project`

Constructor Summary
`DefBase()`

Method Summary
`Path` `createClasspath()` Create the classpath to be used when searching for component being defined
`protected java.lang.ClassLoader` `createLoader()` create a classloader for this definition
`Path` `getClasspath()`
`java.lang.String` `getClasspathId()` Returns the class path id of the class path delegate.
`java.lang.String` `getLoaderId()` Returns the loader id of the class path Delegate.
`void` `init()` Called by the project to let the task initialize properly.
`boolean` `isReverseLoader()`
`void` `setClasspath(Path classpath)` Set the classpath to be used when searching for component being defined
`void` `setClasspathRef(Reference r)` reference to a classpath to use when loading the files.
`void` `setLoaderRef(Reference r)` Use the reference to locate the loader.
`void` `setReverseLoader(boolean reverseLoader)` Deprecated. stop using this attribute

Methods inherited from class org.apache.tools.ant.taskdefs.AntlibDefinition
`getAntlibClassLoader, getURI, setAntlibClassLoader, setURI`

Methods inherited from class org.apache.tools.ant.Task
`execute, getDescription, getLocation, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, isInvalid, log, log, maybeConfigure, perform, reconfigure, setDescription, setLocation, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`

Methods inherited from class org.apache.tools.ant.ProjectComponent
`getProject, setProject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DefBase

    public DefBase()

Method Detail

### setReverseLoader

    public void setReverseLoader(boolean reverseLoader)

  Deprecated. stop using this attribute

  Parameters:
    `reverseLoader` - if true a delegated loader will take precedence over the parent

### getClasspath

    public Path getClasspath()

  Returns:
    the classpath for this definition

### isReverseLoader

    public boolean isReverseLoader()

  Returns:
    the reverse loader attribute of the classpath delegate.

### getLoaderId

    public java.lang.String getLoaderId()

  Returns the loader id of the class path Delegate.

  Returns:
    the loader id

### getClasspathId

    public java.lang.String getClasspathId()

  Returns the class path id of the class path delegate.

  Returns:
    the class path id

### setClasspath

    public void setClasspath(Path classpath)

  Set the classpath to be used when searching for component being defined

  Parameters:
    `classpath` - an Ant Path object containing the classpath.

### createClasspath

    public Path createClasspath()

  Create the classpath to be used when searching for component being defined

  Returns:
    the classpath of the this definition

### setClasspathRef

    public void setClasspathRef(Reference r)

  reference to a classpath to use when loading the files. To actually share the same loader, set loaderref as well

  Parameters:
    `r` - the reference to the classpath

### setLoaderRef

    public void setLoaderRef(Reference r)

  Use the reference to locate the loader. If the loader is not found, taskdef will use the specified classpath and register it with the specified name. This allow multiple taskdef/typedef to use the same class loader, so they can be used together. It eliminate the need to put them in the CLASSPATH.

  Parameters:
    `r` - the reference to locate the loader.
  Since:
    Ant 1.5

### createLoader

    protected java.lang.ClassLoader createLoader()

  create a classloader for this definition

  Returns:
    the classloader from the cpDelegate

### init

    public void init()
              throws BuildException

  Description copied from class: `Task`
  Called by the project to let the task initialize properly. The default implementation is a no-op.

  Overrides:
    `init` in class `Task`
  Throws:
    `BuildException` - if something goes wrong with the build
  Since:
    Ant 1.6
  See Also:
    `Task.init()`

Copyright © 2000-2004 Apache Software Foundation. All Rights Reserved.